The SORTBY function sorts the contents of a range or array based on the values in a corresponding range or array. For example:
Argument
Required
Description
array
Y
The array or range to sort
by_array1
Y
The array or range to sort on
[sort_order1]
N
The order to use for sorting. 1 for ascending, -1 for descending. Default is ascending.
[by_array2]
N
The array or range to sort on
[sort_order2]
N
The order to use for sorting. 1 for ascending, -1 for descending. Default is ascending.
Note:
The SORTBY function is only valid when allowDynamicArray is true.
The SORTBY function will return an array, which will spill if it's the final result of a formula.
An array can be thought of as a row of values, a column of values, or a combination of rows and columns of values.
window.onload = function () {
var spread = new GC.Spread.Sheets.Workbook(_getElementById("ss"));
initSpread(spread);
};
function initSpread(spread) {
spread.options.allowDynamicArray = true;
var sheet = spread.getActiveSheet();
spread.suspendPaint();
spread.suspendCalcService();
sheet.name('SORTBY');
sheet.defaults.colWidth = 80;
sheet.setColumnWidth(0, 20);
sheet.setColumnWidth(1, 20);
sheet.setText(1, 2, 'Use the SORTBY function to sort a range or array based on the values in a corresponding range or array. Syntax: SORTBY(array, by_array1, [sort_order1], [[by_array2], [sort_order2]],…)');
var row = 2;
var col = 2;
var col2 = col + 5;
var formula = 'SEQUENCE(1, 5)';
sheet.setText(row, col, formula);
sheet.setFormula(++row, col, formula);
row++;
applyTableStyleForRange(sheet, row + 1, col, 5, 5);
formula = 'DATE(YEAR(TODAY()), C' + row + ':G' + row +' , 1)';
var formatter = 'mmmm';
sheet.setText(row + 1, col2, ' <--- ' + formula + ' with ' + formatter);
sheet.setFormula(++row, col, formula);
sheet.getRange(row, col, 1, 5).formatter(formatter);
row++;
formula = 'RANDARRAY(4,5)';
formatter = '0.000000'
sheet.setText(row, col2, ' <--- ' + formula + ' with ' + formatter);
sheet.setFormula(row, col, formula);
sheet.getRange(row, col, 4, 5).formatter(formatter);
row += 6;
applyTableStyleForRange(sheet, row, col, 4, 5, { showHeader: false });
formula = 'INT(RANDARRAY(4,5)*100)';
sheet.setFormula(row, col, formula);
sheet.setText(row, col2, ' <--- ' + formula);
row += 6;
applyTableStyleForRange(sheet, row, col, 11, 1);
applyTableStyleForRange(sheet, row, col + 2, 11, 1);
sheet.setText(row - 1, col + 1, 'Random order: SORTBY(C20:C29,RANDARRAY(COUNTA(C20:C29)))');
sheet.setText(row - 1, col + 7, 'Sort range by birthday column: SORTBY(G20:H27,H20:H27)');
formula = 'SEQUENCE(10)'
sheet.setText(row, col, 'Units');
sheet.setText(row, col + 2, 'SortBy');
row++;
sheet.setFormula(row, col, formula);
formula = 'SORTBY(C20:C29,RANDARRAY(COUNTA(C20:C29)))';
sheet.setFormula(row, col + 2, formula);
col += 4;
applyTableStyleForRange(sheet, row - 1, col, 9, 2);
applyTableStyleForRange(sheet, row - 1, col + 3, 9, 2);
sheet.setArray(row - 1, col, [['Name', 'Birthday', '', 'Name', 'Birthday']]);
sheet.setArray(row, col, ["Fritz", "Xi", "Amy", "Sravan", "Tom", "Fred", "Hector", "Sal"]);
sheet.setFormula(row, col + 1, 'RANDARRAY(COUNTA(C20:C27))*40000');
sheet.setFormula(row, col + 3, 'SORTBY(G20:H27,H20:H27)');
formatter = 'mm/dd/yyyy';
sheet.getRange(row, col + 1, 8, 1).formatter(formatter);
sheet.getRange(row, col + 4, 8, 1).formatter(formatter);
spread.resumeCalcService();
spread.resumePaint();
}
function applyTableStyleForRange(sheet, row, col, rowCount, colCount, options) {
var tableName = "tmpTable";
var TableThemes = GC.Spread.Sheets.Tables.TableThemes;
// use table to help set style then remove like convert table to range in Excel
sheet.tables.add(tableName, row, col, rowCount, colCount, TableThemes.medium7, options);
sheet.tables.remove(tableName, 2 /* keep style */);
}
function _getElementById(id) {
return document.getElementById(id);
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script>
<script src="app.js" type="text/javascript"></script>
<link rel="stylesheet" type="text/css" href="styles.css">
</head>
<body>
<div class="sample-tutorial">
<div id="ss" style="width:100%; height: 100%"></div>
</div></body>
</html>
.sample {
position: relative;
height: 100%;
overflow: auto;
}
.sample::after {
display: block;
content: "";
clear: both;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
.option-group {
margin-bottom: 6px;
}
label {
display: block;
margin-bottom: 6px;
}
input {
margin-bottom: 5px;
padding: 2px 4px;
width: 100%;
box-sizing: border-box;
}
input[type=button] {
margin-bottom: 6px;
}
hr {
border-color: #fff;
opacity: .2;
margin: 5px 0;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}

The SORTBY function sorts the contents of a range or array based on the values in a corresponding range or array. For example:
Argument
Required
Description
array
Y
The array or range to sort
by_array1
Y
The array or range to sort on
[sort_order1]
N
The order to use for sorting. 1 for ascending, -1 for descending. Default is ascending.
[by_array2]
N
The array or range to sort on
[sort_order2]
N
The order to use for sorting. 1 for ascending, -1 for descending. Default is ascending.
Note:
The SORTBY function is only valid when allowDynamicArray is true.
The SORTBY function will return an array, which will spill if it's the final result of a formula.
An array can be thought of as a row of values, a column of values, or a combination of rows and columns of values.
<template>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread">
<gc-worksheet>
</gc-worksheet>
</gc-spread-sheets>
</div>
</template>
<script>
import Vue from 'vue';
import '@mescius/spread-sheets-vue'
import GC from '@mescius/spread-sheets';
import './styles.css';
let App = Vue.extend({
name: "app",
methods:{
initSpread: function (spread) {
this.spread = spread;
spread.options.allowDynamicArray = true;
var sheet = spread.getActiveSheet();
spread.suspendPaint();
spread.suspendCalcService();
sheet.name('SORTBY');
sheet.defaults.colWidth = 80;
sheet.setColumnWidth(0, 20);
sheet.setColumnWidth(1, 20);
sheet.setText(1, 2, 'Use the SORTBY function to sort a range or array based on the values in a corresponding range or array. Syntax: SORTBY(array, by_array1, [sort_order1], [[by_array2], [sort_order2]],…)');
var row = 2;
var col = 2;
var col2 = col + 5;
var formula = 'SEQUENCE(1, 5)';
sheet.setText(row, col, formula);
sheet.setFormula(++row, col, formula);
row++;
this.applyTableStyleForRange(sheet, row + 1, col, 5, 5);
formula = 'DATE(YEAR(TODAY()), C' + row + ':G' + row +' , 1)';
var formatter = 'mmmm';
sheet.setText(row + 1, col2, ' <--- ' + formula + ' with ' + formatter);
sheet.setFormula(++row, col, formula);
sheet.getRange(row, col, 1, 5).formatter(formatter);
row++;
formula = 'RANDARRAY(4,5)';
formatter = '0.000000'
sheet.setText(row, col2, ' <--- ' + formula + ' with ' + formatter);
sheet.setFormula(row, col, formula);
sheet.getRange(row, col, 4, 5).formatter(formatter);
row += 6;
this.applyTableStyleForRange(sheet, row, col, 4, 5, { showHeader: false });
formula = 'INT(RANDARRAY(4,5)*100)';
sheet.setFormula(row, col, formula);
sheet.setText(row, col2, ' <--- ' + formula);
row += 6;
this.applyTableStyleForRange(sheet, row, col, 11, 1);
this.applyTableStyleForRange(sheet, row, col + 2, 11, 1);
sheet.setText(row - 1, col + 1, 'Random order: SORTBY(C20:C29,RANDARRAY(COUNTA(C20:C29)))');
sheet.setText(row - 1, col + 7, 'Sort range by birthday column: SORTBY(G20:H27,H20:H27)');
formula = 'SEQUENCE(10)'
sheet.setText(row, col, 'Units');
sheet.setText(row, col + 2, 'SortBy');
row++;
sheet.setFormula(row, col, formula);
formula = 'SORTBY(C20:C29,RANDARRAY(COUNTA(C20:C29)))';
sheet.setFormula(row, col + 2, formula);
col += 4;
this.applyTableStyleForRange(sheet, row - 1, col, 9, 2);
this.applyTableStyleForRange(sheet, row - 1, col + 3, 9, 2);
sheet.setArray(row - 1, col, [['Name', 'Birthday', '', 'Name', 'Birthday']]);
sheet.setArray(row, col, ["Fritz", "Xi", "Amy", "Sravan", "Tom", "Fred", "Hector", "Sal"]);
sheet.setFormula(row, col + 1, 'RANDARRAY(COUNTA(C20:C27))*40000');
sheet.setFormula(row, col + 3, 'SORTBY(G20:H27,H20:H27)');
formatter = 'mm/dd/yyyy';
sheet.getRange(row, col + 1, 8, 1).formatter(formatter);
sheet.getRange(row, col + 4, 8, 1).formatter(formatter);
spread.resumeCalcService();
spread.resumePaint();
},
applyTableStyleForRange: function (sheet, row, col, rowCount, colCount, options) {
var tableName = "tmpTable";
var TableThemes = GC.Spread.Sheets.Tables.TableThemes;
// use table to help set style then remove like convert table to range in Excel
sheet.tables.add(tableName, row, col, rowCount, colCount, TableThemes.medium7, options);
sheet.tables.remove(tableName, 2 /* keep style */);
}
}
});
new Vue({ render: h => h(App) }).$mount('#app');
</script>
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/vue/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- SystemJS -->
<script src="$DEMOROOT$/en/vue/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app.vue');
System.import('$DEMOROOT$/en/lib/vue/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: 100%;
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
#switchAutoMergeMode {
margin: 10px 0px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
meta: {
'*.css': { loader: 'css' },
'*.vue': { loader: 'vue-loader' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'jszip': 'npm:jszip/dist/jszip.js',
'css': 'npm:systemjs-plugin-css/css.js',
'vue': 'npm:vue/dist/vue.min.js',
'vue-loader': 'npm:systemjs-vue-browser/index.js',
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
}
}
});
})(this);

The SORTBY function sorts the contents of a range or array based on the values in a corresponding range or array. For example:
Argument
Required
Description
array
Y
The array or range to sort
by_array1
Y
The array or range to sort on
[sort_order1]
N
The order to use for sorting. 1 for ascending, -1 for descending. Default is ascending.
[by_array2]
N
The array or range to sort on
[sort_order2]
N
The order to use for sorting. 1 for ascending, -1 for descending. Default is ascending.
Note:
The SORTBY function is only valid when allowDynamicArray is true.
The SORTBY function will return an array, which will spill if it's the final result of a formula.
An array can be thought of as a row of values, a column of values, or a combination of rows and columns of values.
import { Component, NgModule, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import GC from '@mescius/spread-sheets';
import './styles.css';
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
spread: GC.Spread.Sheets.Workbook;
hostStyle = {
width: '100%',
height: '100%',
overflow: 'hidden',
float: 'left'
};
constructor() {
}
initSpread($event: any) {
this.spread = $event.spread;
let spread = this.spread;
spread.options.allowDynamicArray = true;
let sheet = spread.getActiveSheet();
spread.suspendPaint();
spread.suspendCalcService();
sheet.name('SORTBY');
sheet.defaults.colWidth = 80;
sheet.setColumnWidth(0, 20);
sheet.setColumnWidth(1, 20);
sheet.setText(1, 2, 'Use the SORTBY function to sort a range or array based on the values in a corresponding range or array. Syntax: SORTBY(array, by_array1, [sort_order1], [[by_array2], [sort_order2]],…)');
let row = 2;
let col = 2;
let col2 = col + 5;
let formula = 'SEQUENCE(1, 5)';
sheet.setText(row, col, formula);
sheet.setFormula(++row, col, formula);
row++;
this.applyTableStyleForRange(sheet, row + 1, col, 5, 5);
formula = 'DATE(YEAR(TODAY()), C' + row + ':G' + row +' , 1)';
let formatter = 'mmmm';
sheet.setText(row + 1, col2, ' <--- ' + formula + ' with ' + formatter);
sheet.setFormula(++row, col, formula);
sheet.getRange(row, col, 1, 5).formatter(formatter);
row++;
formula = 'RANDARRAY(4,5)';
formatter = '0.000000'
sheet.setText(row, col2, ' <--- ' + formula + ' with ' + formatter);
sheet.setFormula(row, col, formula);
sheet.getRange(row, col, 4, 5).formatter(formatter);
row += 6;
this.applyTableStyleForRange(sheet, row, col, 4, 5, { showHeader: false });
formula = 'INT(RANDARRAY(4,5)*100)';
sheet.setFormula(row, col, formula);
sheet.setText(row, col2, ' <--- ' + formula);
row += 6;
this.applyTableStyleForRange(sheet, row, col, 11, 1);
this.applyTableStyleForRange(sheet, row, col + 2, 11, 1);
sheet.setText(row - 1, col + 1, 'Random order: SORTBY(C20:C29,RANDARRAY(COUNTA(C20:C29)))');
sheet.setText(row - 1, col + 7, 'Sort range by birthday column: SORTBY(G20:H27,H20:H27)');
formula = 'SEQUENCE(10)'
sheet.setText(row, col, 'Units');
sheet.setText(row, col + 2, 'SortBy');
row++;
sheet.setFormula(row, col, formula);
formula = 'SORTBY(C20:C29,RANDARRAY(COUNTA(C20:C29)))';
sheet.setFormula(row, col + 2, formula);
col += 4;
this.applyTableStyleForRange(sheet, row - 1, col, 9, 2);
this.applyTableStyleForRange(sheet, row - 1, col + 3, 9, 2);
sheet.setArray(row - 1, col, [['Name', 'Birthday', '', 'Name', 'Birthday']]);
sheet.setArray(row, col, ["Fritz", "Xi", "Amy", "Sravan", "Tom", "Fred", "Hector", "Sal"]);
sheet.setFormula(row, col + 1, 'RANDARRAY(COUNTA(C20:C27))*40000');
sheet.setFormula(row, col + 3, 'SORTBY(G20:H27,H20:H27)');
formatter = 'mm/dd/yyyy';
sheet.getRange(row, col + 1, 8, 1).formatter(formatter);
sheet.getRange(row, col + 4, 8, 1).formatter(formatter);
spread.resumeCalcService();
spread.resumePaint();
}
applyTableStyleForRange(sheet: GC.Spread.Sheets.Worksheet, row: number, col: number, rowCount: number, colCount:number, options?: any) {
let tableName = "tmpTable";
let TableThemes = GC.Spread.Sheets.Tables.TableThemes;
// use table to help set style then remove like convert table to range in Excel
sheet.tables.add(tableName, row, col, rowCount, colCount, TableThemes.medium7, options);
sheet.tables.remove(tableName, 2 /* keep style */);
}
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule {}
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script>
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
<gc-worksheet>
</gc-worksheet>
</gc-spread-sheets>
</div>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);

The SORTBY function sorts the contents of a range or array based on the values in a corresponding range or array. For example:
Argument
Required
Description
array
Y
The array or range to sort
by_array1
Y
The array or range to sort on
[sort_order1]
N
The order to use for sorting. 1 for ascending, -1 for descending. Default is ascending.
[by_array2]
N
The array or range to sort on
[sort_order2]
N
The order to use for sorting. 1 for ascending, -1 for descending. Default is ascending.
Note:
The SORTBY function is only valid when allowDynamicArray is true.
The SORTBY function will return an array, which will spill if it's the final result of a formula.
An array can be thought of as a row of values, a column of values, or a combination of rows and columns of values.
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import './styles.css';
import { AppFunc } from './app-func';
import { App } from './app-class';
// 1. Functional Component sample
ReactDOM.render(<AppFunc />, document.getElementById('app'));
// 2. Class Component sample
// ReactDOM.render(<App />, document.getElementById('app'));
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
import './styles.css';
export function AppFunc() {
const initSpread = (spread) => {
spread.options.allowDynamicArray = true;
var sheet = spread.getActiveSheet();
spread.suspendPaint();
spread.suspendCalcService();
sheet.name('SORTBY');
sheet.defaults.colWidth = 80;
sheet.setColumnWidth(0, 20);
sheet.setColumnWidth(1, 20);
sheet.setText(1, 2, 'Use the SORTBY function to sort a range or array based on the values in a corresponding range or array. Syntax: SORTBY(array, by_array1, [sort_order1], [[by_array2], [sort_order2]],…)');
var row = 2;
var col = 2;
var col2 = col + 5;
var formula = 'SEQUENCE(1, 5)';
sheet.setText(row, col, formula);
sheet.setFormula(++row, col, formula);
row++;
applyTableStyleForRange(sheet, row + 1, col, 5, 5);
formula = 'DATE(YEAR(TODAY()), C' + row + ':G' + row + ' , 1)';
var formatter = 'mmmm';
sheet.setText(row + 1, col2, ' <--- ' + formula + ' with ' + formatter);
sheet.setFormula(++row, col, formula);
sheet.getRange(row, col, 1, 5).formatter(formatter);
row++;
formula = 'RANDARRAY(4,5)';
formatter = '0.000000'
sheet.setText(row, col2, ' <--- ' + formula + ' with ' + formatter);
sheet.setFormula(row, col, formula);
sheet.getRange(row, col, 4, 5).formatter(formatter);
row += 6;
applyTableStyleForRange(sheet, row, col, 4, 5, { showHeader: false });
formula = 'INT(RANDARRAY(4,5)*100)';
sheet.setFormula(row, col, formula);
sheet.setText(row, col2, ' <--- ' + formula);
row += 6;
applyTableStyleForRange(sheet, row, col, 11, 1);
applyTableStyleForRange(sheet, row, col + 2, 11, 1);
sheet.setText(row - 1, col + 1, 'Random order: SORTBY(C20:C29,RANDARRAY(COUNTA(C20:C29)))');
sheet.setText(row - 1, col + 7, 'Sort range by birthday column: SORTBY(G20:H27,H20:H27)');
formula = 'SEQUENCE(10)'
sheet.setText(row, col, 'Units');
sheet.setText(row, col + 2, 'SortBy');
row++;
sheet.setFormula(row, col, formula);
formula = 'SORTBY(C20:C29,RANDARRAY(COUNTA(C20:C29)))';
sheet.setFormula(row, col + 2, formula);
col += 4;
applyTableStyleForRange(sheet, row - 1, col, 9, 2);
applyTableStyleForRange(sheet, row - 1, col + 3, 9, 2);
sheet.setArray(row - 1, col, [['Name', 'Birthday', '', 'Name', 'Birthday']]);
sheet.setArray(row, col, ["Fritz", "Xi", "Amy", "Sravan", "Tom", "Fred", "Hector", "Sal"]);
sheet.setFormula(row, col + 1, 'RANDARRAY(COUNTA(C20:C27))*40000');
sheet.setFormula(row, col + 3, 'SORTBY(G20:H27,H20:H27)');
formatter = 'mm/dd/yyyy';
sheet.getRange(row, col + 1, 8, 1).formatter(formatter);
sheet.getRange(row, col + 4, 8, 1).formatter(formatter);
spread.resumeCalcService();
spread.resumePaint();
}
const applyTableStyleForRange = (sheet, row, col, rowCount, colCount, options) => {
var tableName = "tmpTable";
var TableThemes = GC.Spread.Sheets.Tables.TableThemes;
// use table to help set style then remove like convert table to range in Excel
sheet.tables.add(tableName, row, col, rowCount, colCount, TableThemes.medium7, options);
sheet.tables.remove(tableName, 2 /* keep style */);
}
return <div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => initSpread(spread)}>
<Worksheet>
</Worksheet>
</SpreadSheets>
</div>
</div>;
}
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
import './styles.css';
const Component = React.Component;
export class App extends Component {
render() {
return <div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread=>this.initSpread(spread)}>
<Worksheet>
</Worksheet>
</SpreadSheets>
</div>
</div>;
}
initSpread(spread) {
spread.options.allowDynamicArray = true;
var sheet = spread.getActiveSheet();
spread.suspendPaint();
spread.suspendCalcService();
sheet.name('SORTBY');
sheet.defaults.colWidth = 80;
sheet.setColumnWidth(0, 20);
sheet.setColumnWidth(1, 20);
sheet.setText(1, 2, 'Use the SORTBY function to sort a range or array based on the values in a corresponding range or array. Syntax: SORTBY(array, by_array1, [sort_order1], [[by_array2], [sort_order2]],…)');
var row = 2;
var col = 2;
var col2 = col + 5;
var formula = 'SEQUENCE(1, 5)';
sheet.setText(row, col, formula);
sheet.setFormula(++row, col, formula);
row++;
this.applyTableStyleForRange(sheet, row + 1, col, 5, 5);
formula = 'DATE(YEAR(TODAY()), C' + row + ':G' + row +' , 1)';
var formatter = 'mmmm';
sheet.setText(row + 1, col2, ' <--- ' + formula + ' with ' + formatter);
sheet.setFormula(++row, col, formula);
sheet.getRange(row, col, 1, 5).formatter(formatter);
row++;
formula = 'RANDARRAY(4,5)';
formatter = '0.000000'
sheet.setText(row, col2, ' <--- ' + formula + ' with ' + formatter);
sheet.setFormula(row, col, formula);
sheet.getRange(row, col, 4, 5).formatter(formatter);
row += 6;
this.applyTableStyleForRange(sheet, row, col, 4, 5, { showHeader: false });
formula = 'INT(RANDARRAY(4,5)*100)';
sheet.setFormula(row, col, formula);
sheet.setText(row, col2, ' <--- ' + formula);
row += 6;
this.applyTableStyleForRange(sheet, row, col, 11, 1);
this.applyTableStyleForRange(sheet, row, col + 2, 11, 1);
sheet.setText(row - 1, col + 1, 'Random order: SORTBY(C20:C29,RANDARRAY(COUNTA(C20:C29)))');
sheet.setText(row - 1, col + 7, 'Sort range by birthday column: SORTBY(G20:H27,H20:H27)');
formula = 'SEQUENCE(10)'
sheet.setText(row, col, 'Units');
sheet.setText(row, col + 2, 'SortBy');
row++;
sheet.setFormula(row, col, formula);
formula = 'SORTBY(C20:C29,RANDARRAY(COUNTA(C20:C29)))';
sheet.setFormula(row, col + 2, formula);
col += 4;
this.applyTableStyleForRange(sheet, row - 1, col, 9, 2);
this.applyTableStyleForRange(sheet, row - 1, col + 3, 9, 2);
sheet.setArray(row - 1, col, [['Name', 'Birthday', '', 'Name', 'Birthday']]);
sheet.setArray(row, col, ["Fritz", "Xi", "Amy", "Sravan", "Tom", "Fred", "Hector", "Sal"]);
sheet.setFormula(row, col + 1, 'RANDARRAY(COUNTA(C20:C27))*40000');
sheet.setFormula(row, col + 3, 'SORTBY(G20:H27,H20:H27)');
formatter = 'mm/dd/yyyy';
sheet.getRange(row, col + 1, 8, 1).formatter(formatter);
sheet.getRange(row, col + 4, 8, 1).formatter(formatter);
spread.resumeCalcService();
spread.resumePaint();
}
applyTableStyleForRange(sheet, row, col, rowCount, colCount, options) {
var tableName = "tmpTable";
var TableThemes = GC.Spread.Sheets.Tables.TableThemes;
// use table to help set style then remove like convert table to range in Excel
sheet.tables.add(tableName, row, col, rowCount, colCount, TableThemes.medium7, options);
sheet.tables.remove(tableName, 2 /* keep style */);
}
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: 100%;
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
#switchAutoMergeMode {
margin: 10px 0px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
#app {
height: 100%;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/umd/react.production.min.js',
'react-dom': 'npm:react-dom/umd/react-dom.production.min.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);